Alya - Task #17944

Implement slow queries: client library
15/02/2024 10:15 AM - Sachin Divekar

Status: Closed Start date:

Priority: Normal Due date: 15/03/2024
Assignee: Sachin Divekar % Done: 100%
Category: Estimated time: 0.00 hour
Target version: Sprint 29 Mar

Description

This includes the library functions which enqueue a slow query, the function which checks if done, and the function to abort, the
function to register the initialiser for an app and the processing function for a query type, etc. It does not include the framework for the
asynchronous processing functions.

Associated revisions

Revision 24fd1b2a - 08/03/2024 08:09 AM - Sachin Divekar
WIP: slowquery and jobmanager refs #17944 #18088

This commit has an end to end example of slowquery request. slowquery.go has Done() and Submit() functions of slowquery. example-report/main.go
is a sample application that submits a slowquery and checks for updates by calling Done.

jobmanager.go has JobManager() and other related functions. Currently, it successfully registers initializers, initblocks, slowquery processors and
correctly accesses them while processing a slowquery.

This is WIP. A lot of code will change for correctness and overall refactoring.
Revision ddff0876 - 12/03/2024 07:59 AM - Sachin Divekar
Implement Submit, Done and Abort for batches #17943 #18088 #17944

® Implement Submit, Done and Abort for batches

¢ Implement Abort for slowquery
¢ Write programs to use and test them

Revision d4fa2389 - 14/03/2024 10:49 PM - Sachin Divekar
Implement batch Abort and Waitoff refs #17943 #18088 #17944
Implement batch Abort and Waitoff

Refactor code for better organization and simplicity

Revision 5bad17fa - 18/03/2024 11:34 PM - Sachin Divekar
Implement object storage integration #17943 #18088 #17944

Revision 4f8c6fca - 10/04/2024 11:39 PM - Sachin Divekar
Update example programs to use minio #17943 #17944

Revision 87ca45da - 12/04/2024 01:06 AM - Sachin Divekar
Provide MigrateDatabase function to migrate alya batch related tables #17943 #17944

Revision 17807588 - 12/04/2024 01:33 AM - Sachin Divekar

Convert op (operation) param value to lowercase before inserting into database #17943 #17944

Revision f1a9ff40 - 15/04/2024 01:21 PM - Sachin Divekar
Use sync.Map for Processor registration #17943 #17944

Replace regular map and mutex with sync.Map to manage the registration and retrieval of slow query processor functions.

Rationale:
e sync.Map is optimized for scenarios where there are many reads and infrequent writes, which aligns with our usage pattern of registering
processors once and querying them frequently.

¢ The use of sync.Map reduces the complexity of manual locking and unlocking, thus lowering the risk of deadlocks and improving performance on
concurrent access.

Revision e719dec5 - 15/04/2024 11:37 PM - Sachin Divekar
Write test for Registerlnitializer and add comments #17943 #17944

History

#1 - 16/02/2024 06:13 PM - Shuvam Misra
- Target version set to Sprint 15 Mar
- Assignee set to Sachin Divekar

- Due date set to 15/03/2024

#2 - 29/02/2024 10:15 PM - Sachin Divekar

- Status changed from New to In Progress

#3 - 29/02/2024 10:19 PM - Sachin Divekar
- % Done changed from 0 to 10

Wrote Submit() and Done() functions of slowqueries module.

#4 - 07/03/2024 05:41 PM - Shuvam Misra

- Description updated

#5 - 07/03/2024 05:44 PM - Shuvam Misra
- Description updated

- Subject changed from Implement slow queries to Implement slow queries: client library

#6 - 08/03/2024 08:58 AM - Sachin Divekar
- % Done changed from 10 to 60

Wrote a sample application that submits a slowquery and then checks for its status using done. This is WIP. Code changes will be done for
correctness, readability and organization.

#7 - 12/03/2024 08:03 AM - Sachin Divekar
- % Done changed from 60 to 80

Implemented Abort for slowquery and wrote a program to use it and verify its working.

#8 - 20/03/2024 03:23 PM - Shuvam Misra
- Target version changed from Sprint 15 Mar to Sprint 29 Mar

#9 - 26/03/2024 07:19 PM - Shuvam Misra
- Target version changed from Sprint 29 Mar to Sprint 12 Apr

#10 - 26/03/2024 07:21 PM - Shuvam Misra
- Target version changed from Sprint 12 Apr to Sprint 29 Mar

#11 - 26/03/2024 07:22 PM - Shuvam Misra

- Status changed from In Progress to Testing

#12 - 26/03/2024 07:27 PM - Shuvam Misra
- % Done changed from 80 to 100

#13 - 29/04/2024 09:04 AM - Sachin Divekar

- Status changed from Testing to Closed
